	PAGE	88,132
	TITLE	DODUMP -- EGAD Screen Print (c) 1993 LS Software
	SUBTTL	Set up data areas and call EGAD Printer Driver
;
;	EGAD Screen Print
;
;	COPYRIGHT (C) 1988-1990 LS Software
;
; Routine to manage screen dump for for stand-alone screen print driver
; 10/22/88 1130
;
; Routines used:
;	GET_BOX
;
;

	PUBLIC	DO_DUMP, WORK_CFG

	INCLUDE	GLOBAL.INC

_DATA	SEGMENT WORD PUBLIC 'DATA'
	EXTRN	PALETTE_2:WORD,PALETTE_4:WORD
	EXTRN	PALETTE_16:WORD,PALETTE_TEXT:WORD
	EXTRN	ERRCOD:WORD
	EXTRN	DISP_COLS:WORD, DISP_ROWS:WORD, VIDEO_MODE:BYTE
	EXTRN	TSR:BYTE
	EXTRN	VMODE_TYPE:WORD
_DATA		ENDS

	ASSUME	CS:_TEXT, DS:NOTHING, SS:STACK, ES:NOTHING

	EXTRN	GET_BOX:PROC
	EXTRN	GETMODE:PROC
	EXTRN	GET_MODE_PTR:PROC
	EXTRN	EGAD_DRV:PROC

_DATA	SEGMENT

WORK_CFG config_data <>

palette_table dw PALETTE_2, PALETTE_4, PALETTE_16, PALETTE_TEXT

_DATA	ENDS

; Routine to show screen dump extent box and allow user
; to select area to dump.
; USES: AX, BX, DX, SI, DI

_TEXT	SEGMENT
DO_DUMP	PROC NEAR
	PUSH	BP
	MOV	BP,SP
	push	cx
	push	es
	push	ds
	mov	ax,_DATA
	mov	ds,ax
	mov	es,ax
	ASSUME	DS:_DATA,ES:_DATA

; Copy TSR structure block to working copy
	; WL 11/19/92
	mov	di,offset work_cfg
	mov	si,offset tsr
	mov	cx,CFG_LEN
	cld			; forward move
	rep	movsb

	; Make coordinates 0-based
	; WL 11/19/92
	dec	work_cfg.x1
	dec	work_cfg.x2
	dec	work_cfg.y1
	dec	work_cfg.y2

DD2:	call	getmode
	call	get_mode_ptr

; Get parameters from table
	mov	al,vmode_type[bx].vmode_definc	; Get increment
	cbw
	mov	work_cfg.incr,ax

; Establish initial box
	sub	ax,ax			; AX = 0
	cmp	work_cfg.x2,ax		; If x2 = 0, choose whole screen;
	jne	user_input		; else use existing size

	mov	work_cfg.x1,ax		; Upper left corner at (0,0)
	mov	work_cfg.y1,ax

	mov	ax,disp_cols		; Lower left corner at
	dec	ax
	mov	work_cfg.x2,ax		;   screen size
	mov	ax,disp_rows
	dec	ax
	mov	work_cfg.y2,ax

user_input:

; Test to see if crop box is wanted
	mov	cx,work_cfg.box
	jcxz	done_input

	call	get_box		; Adjust crop box & return last keystroke
	cmp	ax,xmode_key	; Toggle GRAPHICS/TEXT/NORMAL mode
	je	DD2		; Get new video mode
	cmp	ax,Escape_key	; ESC key hit, just exit
	je	exit
	; Assume ENTER pressed

; Get palette parameter from table.  Because we allow the user
; to toggle between Hercules text & graphics modes, we must get
; the mode number again here.
done_input:
	call	getmode
	call	get_mode_ptr
	mov	bl,vmode_type[bx].vmode_palette	; Palette for this mode
	and	bl,vm_pal_pbits			; Palette info only
	sub	bh,bh
	add	bx,bx			; Offset * 2
	add	bx,offset palette_table	; Point into table
	mov	ax,word ptr [bx]	; AX is address of palette

; Push arguments on stack
	push	ds			; Address of palette
	push	ax
	mov	ax,OFFSET WORK_CFG	; Address of config. structure
	push	ds
	push	ax
	mov	ax,OFFSET ERRCOD	; Address to save error code
	push	ds
	push	ax

	call	far ptr EGAD_DRV
	xor	ax,ax		; Indicate Escape key not hit
skip:
;
exit:
	pop	ds
	pop	es
	pop	cx
	POP	BP
	retn
;
DO_DUMP	ENDP
_TEXT	ENDS
	END

