	PAGE	88,132
	SUBTTL	DRV_LBP: Canon LBP
;
;	EGAD Screen Print
;
;	COPYRIGHT (C) 1995 LS Software
; ********************************************
; DRIVERS FOR:
;
; Canon LBP (LED Beam Printers)
;	LBP-4
;	LBP-8
;	etc.
; ********************************************
; 

	PRN_CHRSET = CHRSET_PC8	; IBM PC set available

	PRN_BYTE	= BYTE_HORIZ
	PRN_GR		EQU	GR_DE2
	GR_DEC_DIGITS	EQU	3
	HORIZ_BYTES	EQU	TRUE
	GSET_PER_MODE	EQU	TRUE	; Setup strings for each graphic mode

	;
	;	GMAP: Table of screen resolutions to printer resolutions.
	;	(** See comment below about REPEAT field on HP printer **)
	;
	;	X & Y are limits of full page enlargement.
	;
	;	Printer Horizontal: Resolution (dpi) * Screen Pixels/Byte
	;		[* 8 inches / 8 bit/bytes -- these cancel]
	;	Printer Vertical: Resolution (dpi) * 10 Inches /
	;		Repeat Factor

	;	Graphics Mode definitions.
	;

	PMODE_PRT0	LABEL WORD
	PMODE_PRT1	LABEL WORD
	PMODE_PRT2	LABEL WORD
			DW 5+(GR_DEC_DIGITS*2)
			DB	27,'['
	PMODE_LEN0	LABEL	BYTE
	PMODE_LEN1	LABEL	BYTE
	PMODE_LEN2	LABEL	BYTE
			DB	gr_dec_digits dup (0)	; Count goes here
			DB	';'
	PMODE_LENALL	DB	gr_dec_digits dup (0)	; Second count goes here
			DB	'.r'		; Send one scan line.
						; always pretends rasters are
						; 300 bytes wide, but only sends
						; the actual data.


	;  resolutions:
	GMODES	LABEL	WORD
		PRNMODE 0, 100, 100
		PRNMODE	1, 150, 150
		PRNMODE	2, 300, 300
	MAXMODE	EQU	2
	BUFLEN	EQU	RESX2 + 2

	GSETUP	DW	GSET800,GSET1200,GSET2400

	; These all allow a maximum of 300 bytes x 3150 dots (8.0"x10.5")
	; maximum graphics area.
	EGADSTR GSET800,<27,'[100;3150;100&u'>  ; 100 dpi
	EGADSTR GSET1200,<27,'[150;3150;150&u'> ; 150 dpi
	EGADSTR GSET2400,<27,'[300;3150;300&u'> ; 300 dpi

	;        prn                    (1/10")
	;      # mode  rep rot pattern  x"   y"
	; Normal (Best Ratio)
	GFXMAP 0,  0,   2,  0,     5, 80, 103	; 320x200 5.1x4.0" P
	GFXMAP 1,  1,   3,  0,     7, 80, 103	; 640x200 5.3x6.4" P
	GFXMAP 2,  1,   2,  1,     3, 80, 103	; 640x350 8.5x6.2" L
	GFXMAP 3,  1,   2,  1,     4, 80, 103	; 640x480 8.5x6.4" L
	GFXMAP 4,  1,   2,  0,     6, 80, 103	; 720x348 6.4x4.6" P
	GFXMAP X,  2,   2,  0,     4, 80, 103	; Reduce (300 dpi)
	; Alternates
	GFXMAP 10, 1,   3,  1,	   2, 80, 103	; 320x200 5.3x6.4" L
	GFXMAP 11, 1,   1,  1,	   3, 80, 103	; 640x200 3.6x4.3" L
	GFXMAP 12, 1,   2,  0,	   6, 80, 103	; 640x350 6.8x4.7" P
	GFXMAP 13, 0,   1,  0,	   8, 80, 103	; 640x480 6.4x4.8" P
	GFXMAP 14, 1,   1,  1,	   5, 80, 103	; 720x348 4.8x3.7" L
	GFXMAP 1X, 2,   2,  1,	   4, 80, 103	; Reduce (300 dpi)
	GFXMAP_END LABEL BYTE

	; These codes are sent *before* we enter the graphics modes.
	GXSETUP	DW	GSET_END-GSET_START
	GSET_START LABEL BYTE
		DB	27,';'		; ISO mode
		DB	27,'[11h'	;
		DB	27,'[?2h'	; disable auto FF
		DB	27,'[1v'	; 1 copy
		DB	27,'[7',32,'I'	; Set line spacing for movement
		DB	27,'[30;;p'	; Letter page, Portrait mode
	;	DB	27,'[0#x'	; single sided printing
		DB	27,'[0d'	; Move absolute vertical
		DB	27,'[60k'	; Move up 60 lines (1st printable scan)
		DB	27,'[0`'	; Move absolute horizontal
	GSET_END LABEL BYTE

	; End raster graphics transfer:
	EGADSTR	NSPACE,<>

	EGADSTR GR_OFF,<>		; No end-graphics code
	EGADSTR	CR,<13>			; CR only
	EGADSTR CRLF,<13,10>		; CR/LF pair
	EGADSTR PRINTER_RESET,<27,'<'>
		; Reset-printer code [Soft-Reset]
		; (Reset sent before beginning job if desired.)

	EGADSTR QUOTE_CHAR,<27,'[.v'>	; Print Control Character

	EGADSTR MLCRLF,<> 		; Nothing sent between gfx rows

	EGADSTR EXT_CHARS,<27,';',27,')',27h,20h,31h>
		; <Esc>;	Enters ISO mode
		; <Esc>)'<sp>1	select IBMR1 as secondary char set

 IF 0
	; Support text attributes.
	TEXT_ATTRS LABEL WORD
		DW	text_nor	; 0
		DW	text_bold	; 1
		DW	text_undr	; 2
		DW	text_ital	; 3

	N_TEXT_ATTRS EQU (($-TEXT_ATTRS)/2)-1 ; normally 3

	EGADSTR TEXT_NOR, <>
	EGADSTR TEXT_BOLD,<>
	EGADSTR TEXT_UNDR,<>
	EGADSTR TEXT_ITAL <>
 ENDIF


	;	Raster graphic commands produce one horizontal line of dots.
	;	The MSB is on the left of each byte. (The REPEAT field allows
	;	us to dither into multiple print rows.)

	PATTERN 2, 2, 8		; 2 Screen Lines per print column
	PATTERN_200 EQU PATTERN_2
		db	11110000b
		db	00001111b
	PATTERN	3, 3, 8		; 3 Screen Lines per print column
		db	11000000b
		db	00111000b
		db	00000111b
	PATTERN 4, 4, 8		; 4 Screen Lines per print column
		db	11000000b
		db	00110000b
		db	00001100b
		db	00000011b
	PATTERN	5, 5, 8		; 5 Screen Lines per print column
		db	10000000b
		db	01100000b
		db	00011000b
		db	00000100b
		db	00000011b
	PATTERN	6, 6, 8		; 6 Screen Lines per print column
		db	10000000b
		db	01100000b
		db	00010000b
		db	00001000b
		db	00000110b
		db	00000001b
	PATTERN	7, 7, 8		; 7 Screen Lines per print column
		db	10000000b
		db	01000000b
		db	00100000b
		db	00010000b
		db	00001000b
		db	00000110b
		db	00000001b
	PATTERN	8, 8, 8		; 8 Screen Lines per print column
		db	10000000b
		db	01000000b
		db	00100000b
		db	00010000b
		db	00001000b
		db	00000100b
		db	00000010b
		db	00000001b
		db	0		; end of patterns

	; 4 Dither levels, but 2 dither tables (entries taken from
	; the B&W printer's dither tables.)
	DITHER_LEVELS	EQU 4			; # of dither patterns
	DITHER_WIDTH	EQU 1			; 1 byte per level
	NDITHERS	EQU 4			; 4 dither tables

	DITHER_TABLE LABEL WORD
		DB	000H,022H,055H,0FFH	; 1st line
		DB	000H,011H,0AAH,0FFH	; 2nd line
		DB	000H,044H,055H,0FFH	; 3rd line
		DB	000H,088H,0AAH,0FFH	; 4th line

	; End of Canon LBP printer support
