; ********************************************
; DRIVERS FOR:
;
; Toshiba P3x1 (These are Qume daisy-wheel compatible [ !!! ])
; ********************************************
; 

IF (prn_mdl eq mdl_ToshP3x1)
	prn_chrset	= chrset_ascii7
	prn_byte	= byte_vert
	PRN_GR 	= GR_DEC OR GR_COLS
	GR_DEC_DIGITS	= 4
	PIN24		= 4		; Uses 4 passes, 6 bits each.
	prn_chrset	= chrset_pc8	; IBM character Set

	;	Graphics Mode definitions.
	;

	;        prn                    (1/10")
	;      # mode  rep rot pattern  x"   y"
	GFXMAP 0,  0,    2,  1,      4, 80, 105
	GFXMAP 1,  0,    3,  1,      5, 80, 105
	GFXMAP 2,  0,    3,  1,      3, 80, 105
	GFXMAP 3,  0,    2,  0,      3, 80, 105
	GFXMAP 4,  0,    2,  1,      5, 80, 105
	GFXMAP X,  0,    2,  0,      3, 80, 105
	; Alternate modes
	GFXMAP 10, 0,    3,  0,      2, 80, 105
	GFXMAP 11, 0,    1,  0,      3, 80, 105
	GFXMAP 12, 0,    1,  0,      5, 80, 105
	GFXMAP 13, 0,    2,  1,      3, 80, 105
	GFXMAP 14, 0,    2,  0,      2, 80, 105
	GFXMAP 1X, 0,    2,  1,      3, 80, 105
	gfxmap_end label word

	GMODES	LABEL	WORD
		PRNMODE	0, 180, 193
	; 193x180 dpi is "apparent" resolution.  Print pins are on 1/180"
	; spacing, and there are 24 of them, but vertical spacing is
	; specified in 1/48" increments; 24/180" is 6.4/48" (!!!)
	; In short, 48ths and 180ths are incompatible!

	MAXMODE	EQU	0

	PMODE_PRT0	DW 6
			DB	27,';'
	PMODE_LEN0	DB	gr_dec_digits dup (0)	; Count goes here

	EGADSTR	GR_OFF,<>		; Inter-ribbon code unused as B&W
	EGADSTR	CR,<13>			; CR only
	MLCRLF LABEL WORD		; Same as CRLF:
	EGADSTR CRLF,<13,10>		; CR/LF pair

	; Set printer to graphics spacing:
	EGADSTR GSETUP,<27,'L06'>
	; Reset printer to 1/6" spacing:
	EGADSTR NSPACE,<27,'L08'>

	;	Text mode, Attribute definitions.  Not for color printers.

	TEXT_ATTRS LABEL WORD
		DW	text_nor	; 0
		DW	text_emph	; 1
		DW	text_und	; 2
		DW	text_emun	; 3

	N_TEXT_ATTRS EQU (($-TEXT_ATTRS)/2)-1 ; normally 3

	EGADSTR TEXT_NOR, <27,'R',27,'J'>	; Shadow & u.l. off
	EGADSTR TEXT_EMPH,<27,'Q'>		; Shadow print
	EGADSTR TEXT_UND, <27,'I'>		; Underlined
	EGADSTR TEXT_EMUN,<27,'Q',27,'I'>	; Underlined & shadow

	;	1440 columns (180 dpi * 8") per pass (+2 bytes length)
	BUFLEN	EQU	1440+2

	;	6 bits, MSB on top
	PATTERN 200, 6, 6
		db	00100000b
		db	00010000b
		db	00001000b
		db	00000100b
		db	00000010b
		db	00000001b
	PATTERN 3, 3, 6
		db	00110000b
		db	00001100b
		db	00000011b
	PATTERN 2, 2, 6
		db	00111000b
		db	00000111b
	PATTERN 4, 4, 6
		db	00110000b
		db	00001000b
		db	00000110b
		db	00000001b
	PATTERN 5, 5, 6
		db	00110000b
		db	00001000b
		db	00000100b
		db	00000010b
		db	00000001b
		db	0		; end of patterns

	; 8 dither levels
	DITHER_LEVELS	EQU 8			; # of dither patterns
	DITHER_WIDTH	EQU 8			; bytes per pattern
	NDITHERS	EQU 1			; 1 dither table

	DITHER_TABLE LABEL WORD
	 ; !!!NOTE!!! Do not set "adjacent" bits (as interpreted
	 ; by the printer) or the P1340 printer may self-destruct.
	 DB	   0,   0,   0,   0,   0,   0,   0,   0	; 0-Level Dither
	 DB	0AAH,   0,   0,   0,055H,   0,   0,   0 ; 1-
	 DB	0AAH,   0,055H,   0,0AAH,   0,055H,   0 ; 2-
	 DB	011H,044H,022H,088H,011H,022H,044H,088H ; 3-
	 DB	0AAH,055H,   0,055H,0AAH,055H,   0,055H ; 4-
	 DB	0AAH,011H,044H,055H,0AAH,011H,044H,055H ; 5-
	 DB	0AAH,011H,0AAH,044H,0AAH,011H,0AAH,044H ; 6-
	 DB	0AAH,055H,0AAH,055H,0AAH,055H,0AAH,055H ; 7-

	; End of Toshiba code
ENDIF
