#
# MAKE FILE FOR EGAD Screen Print		Version 2.40
# Copyright (c) 1990, 1991, 1992 LS Software
#
#

DRIVER_COMMON=egaddrv.asm egaddata.asm global.inc macros.inc xlat.inc

LINK_OPTS=/NOI/E

ASM=MASM
# ASM=TASM /jQUIRKS /m2
ASM_OPTS=/MX$(DEBUG)

#LIST=$*.lst
LIST=NUL

#DEBUG=/DDEBUG
DEBUG=

prn_typ=/DPRN_TYP=TYP_
prn_mfg=/DPRN_MFG=MFG_
prn_mdl=/DPRN_MDL=MDL_

#
# By substituting GETBOX_S.OBJ for GETBOX.OBJ, the action of the Crop box
# is disabled.  /B is thus useless.  Unless the /R switch is used, the whole
# screen will always be printed.  -- wl 12/11/92
#
# LINK_COMMON=egadoem.obj dodump.obj getbox_s.obj

# GETBOX_L will allow cropping, but has limited functionality.
# -- wl 12/22/92
# LINK_COMMON=egadoem.obj dodump.obj getbox_l.obj dline.obj

# And here is the statement for the Standard version:
LINK_COMMON=egad.obj dodump.obj getbox.obj dline.obj

#
#   *** ALSO Remember to change the COPY/MOVE command @ the bottom! ***
#

.asm.obj:
	$(ASM) $(ASM_OPTS) $*.asm,,$(LIST);
# Below line makes Listing files:
#	$(ASM) $(ASM_OPTS) $*.asm,,$*;

.obj.exe:
	link	$(LINK_OPTS) $**;

#
#		Common to all drivers:
#

dodump.obj:	$*.asm global.inc

getbox.obj:	$*.asm global.inc

# GETBOX_S is the "stub" version of GETBOX -- it does nothing.

getbox_s.obj:	$*.asm global.inc

# GETBOX_L allows cropping, but has limited functionality.

getbox_l.obj:	getbox.asm global.inc
	$(ASM) $(ASM_OPTS) /DLIMITED getbox.asm,getbox_l.obj,$(LIST);

dline.obj:	$*.asm global.inc

egad.obj:	$*.asm global.inc version.inc egad.mk

egadoem.obj:	egad.asm global.inc version.inc egad.mk
	$(ASM) $(ASM_OPTS) /DOEM egad.asm,egadoem.obj,$(LIST);

video_pc.obj:	$*.asm global.inc

video_z.obj:	$*.asm global.inc

#
#		EGADEP - Epson & Compatible printers
#

egadep.obj:	$(DRIVER_COMMON) drv_ep9.inc
	$(ASM) $(PRN_TYP)MATRIX $(PRN_MFG)EPSON $(PRN_MDL)EPFX $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadep.exe:	egadep.obj $(LINK_COMMON) video_pc.obj

#
#		EGADEPW - Epson & Compatible printers, Wide carriage
#

egadepw.obj:	$(DRIVER_COMMON) drv_ep9.inc
	$(ASM) $(PRN_TYP)MATRIX $(PRN_MFG)EPSON $(PRN_MDL)EPFX /DWIDE $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadepw.exe:	egadepw.obj $(LINK_COMMON) video_pc.obj

#
#		EGADMX - Epson MX-80 with GrafTrax (120 dpi only)
#

egadmx.obj:	$(DRIVER_COMMON) drv_ep9.inc
	$(ASM) $(PRN_TYP)MATRIX $(PRN_MFG)EPSON $(PRN_MDL)EPMX $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadmx.exe:	egadmx.obj $(LINK_COMMON) video_pc.obj

#
#		EGADST - For Star Gemini, Delta, Radix,
#			 SG, SD, and SR printers
#

egadst.obj:	$(DRIVER_COMMON) drv_ep9.inc
	$(ASM) $(PRN_TYP)MATRIX $(PRN_MFG)EPSON $(PRN_MDL)EPST $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadst.exe:	egadst.obj $(LINK_COMMON) video_pc.obj

#
#		EGADEPC - Epson & Compatible Color Printers
#

egadepc.obj:	$(DRIVER_COMMON) drv_ep9.inc
	$(ASM) $(PRN_TYP)COLORMATRIX $(PRN_MFG)EPSON $(PRN_MDL)EPFX $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadepc.exe:	egadepc.obj $(LINK_COMMON) video_pc.obj

#
#		EGADEPCW - Epson & Compatible Color Printers, Wide Carriage
#

egadepcw.obj:	$(DRIVER_COMMON) drv_ep9.inc
	$(ASM) $(PRN_TYP)COLORMATRIX $(PRN_MFG)EPSON $(PRN_MDL)EPFX /DWIDE $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadepcw.exe:	egadepcw.obj $(LINK_COMMON) video_pc.obj

#
#		EGADPP - IBM ProPrinter & Compatibles
#			NOTE: Now uses 24-pin High resolution mode
#

egadpp.obj:	$(DRIVER_COMMON) drv_ep24.inc
	$(ASM) $(PRN_TYP)MAT24 $(PRN_MFG)IBM $(PRN_MDL)IBMX24 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

#			NOTE: 9-pin ProPrinter II:
#	$(ASM) $(PRN_TYP)MAT24 $(PRN_MFG)IBM $(PRN_MDL)IBMPP $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadpp.exe:	egadpp.obj $(LINK_COMMON) video_pc.obj

#
#		EGADLQ - 24-pin Epson LQ/Compatible
#			NOTE: For 24-pin printers. Uses 180x180 dpi graphics.
#

egadlq.obj:	$(DRIVER_COMMON) drv_ep24.inc
	$(ASM) $(PRN_TYP)MAT24 $(PRN_MFG)EPSON $(PRN_MDL)EPLQ $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadlq.exe:	egadlq.obj $(LINK_COMMON) video_pc.obj

#
#		EGADLQW - 24-pin Epson LQ/Compatible, Wide Carriage
#			NOTE: For 24-pin printers. Uses 180x180 dpi graphics.
#

egadlqw.obj:	$(DRIVER_COMMON) drv_ep24.inc
	$(ASM) $(PRN_TYP)MAT24 $(PRN_MFG)EPSON $(PRN_MDL)EPLQ /DWIDE $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadlqw.exe:	egadlqw.obj $(LINK_COMMON) video_pc.obj

#
#		EGADLQC - Epson-LQ & compatible 24-pin COLOR matrix
#			NOTE: For 24-pin printers, with 1/60" instead of
#			1/72" vertical dots.
#

egadlqc.obj:	$(DRIVER_COMMON) drv_ep9.inc
	$(ASM) $(PRN_TYP)COLORMAT24 $(PRN_MFG)EPSON $(PRN_MDL)EPFX $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadlqc.exe:	egadlqc.obj $(LINK_COMMON) video_pc.obj

egadlqcx.obj:	$(DRIVER_COMMON) drv_ep24.inc
	$(ASM) $(PRN_TYP)COLORMAT24 $(PRN_MFG)EPSON $(PRN_MDL)EPLQ $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadlqcx.exe:	egadlqcx.obj $(LINK_COMMON) video_pc.obj

#
#		EGADLQCW - Epson-LQ & compatible 24-pin COLOR matrix, Wide Carriage
#			NOTE: For 24-pin printers, with 1/60" instead of
#			1/72" vertical dots.
#

egadlqcw.obj:	$(DRIVER_COMMON) drv_ep9.inc
	$(ASM) $(PRN_TYP)COLORMAT24 $(PRN_MFG)EPSON $(PRN_MDL)EPFX /DWIDE $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadlqcw.exe:	egadlqcw.obj $(LINK_COMMON) video_pc.obj

#
#		EGADHP - For HP LaserJet
#

egadhp.obj:	$(DRIVER_COMMON) drv_hp.inc
	$(ASM) $(PRN_TYP)LASER $(PRN_MFG)HP $(PRN_MDL)HPLJ $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadhp.exe:	egadhp.obj $(LINK_COMMON) video_pc.obj

#		EGADHP2 - LaserJet Series II or above

egadhp2.obj:	$(DRIVER_COMMON) drv_hp.inc
	$(ASM) $(PRN_TYP)LASER $(PRN_MFG)HP $(PRN_MDL)HPLJ2 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadhp2.exe:	egadhp2.obj $(LINK_COMMON) video_pc.obj

#		EGADHP3 - LaserJet IID, IIP, Series III
#			  (with data compression mode)

egadhp3.obj:	$(DRIVER_COMMON) drv_hp.inc
	$(ASM) $(PRN_TYP)LASER $(PRN_MFG)HP $(PRN_MDL)HPLJ3 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadhp3.exe:	egadhp3.obj $(LINK_COMMON) video_pc.obj

#
#		EGADQJ - For HP QuietJet
#

egadqj.obj:	$(DRIVER_COMMON) drv_hp.inc
	$(ASM) $(PRN_TYP)INKJET $(PRN_MFG)HP $(PRN_MDL)HPQJ $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadqj.exe:	egadqj.obj $(LINK_COMMON) video_pc.obj

#
#		EGADPJ - For HP Paintjet
#

egadpj.obj:	$(DRIVER_COMMON) drv_hp.inc
	$(ASM) $(PRN_TYP)COLORINKJET $(PRN_MFG)HP $(PRN_MDL)HPPJ $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadpj.exe:	egadpj.obj $(LINK_COMMON) video_pc.obj

#
#		EGADDJ - For HP DeskJet 500
#

egaddj5.obj:	$(DRIVER_COMMON) drv_hp.inc
	$(ASM) $(PRN_TYP)INKJET $(PRN_MFG)HP $(PRN_MDL)HPDJ500 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egaddj5.exe:	egaddj5.obj $(LINK_COMMON) video_pc.obj

#
#		EGADDJ5C - For HP DeskJet 500C
#

egaddj5c.obj:	$(DRIVER_COMMON) drv_hp.inc
	$(ASM) $(PRN_TYP)COLORINKJET $(PRN_MFG)HP $(PRN_MDL)HPDJ500 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egaddj5c.exe:	egaddj5c.obj $(LINK_COMMON) video_pc.obj

#
#		EGADDJ55 - For HP DeskJet 550C
#

egaddj55.obj:	$(DRIVER_COMMON) drv_hp.inc
	$(ASM) $(PRN_TYP)COLORINKJET $(PRN_MFG)HP $(PRN_MDL)HPDJ550 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egaddj55.exe:	egaddj55.obj $(LINK_COMMON) video_pc.obj

#
#		EGADPOST - For PostScript devices
#
egadpost.obj:	$(DRIVER_COMMON) drv_post.inc
	$(ASM) $(PRN_TYP)LASER $(PRN_MFG)ADOBE $(PRN_MDL)LEVEL1 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadpost.exe:	egadpost.obj $(LINK_COMMON) video_pc.obj

#
#		EGADPSC - For PostScript *color* devices
#
egadpsc.obj:	$(DRIVER_COMMON) drv_post.inc
	$(ASM) $(PRN_TYP)COLORLASER $(PRN_MFG)ADOBE $(PRN_MDL)LEVEL2 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadpsc.exe:	egadpsc.obj $(LINK_COMMON) video_pc.obj

#
#		EGADPCPI - PCPI LaserImage 2000
#

egadpcpi.obj:	$(DRIVER_COMMON) drv_pcpi.inc
	$(ASM) $(PRN_TYP)LASER $(PRN_MFG)PCPI $(PRN_MDL)PCPI2000 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadpcpi.exe:	egadpcpi.obj $(LINK_COMMON) video_pc.obj

#
#		EGADNEC - For NEC-8023 and C. Itoh 8510 printers
#

egadnec.obj:	$(DRIVER_COMMON) drv_nec.inc
	$(ASM) $(PRN_TYP)MATRIX $(PRN_MFG)NEC $(PRN_MDL)NEC8023 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadnec.exe:	egadnec.obj $(LINK_COMMON) video_pc.obj

#
#		EGADDP - For Dataproducts 8050 printers
#

egaddp.obj:	$(DRIVER_COMMON) drv_dp.inc
	$(ASM) $(PRN_TYP)COLORMATRIX $(PRN_MFG)DP $(PRN_MDL)DP8050 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egaddp.exe:	egaddp.obj $(LINK_COMMON) video_pc.obj

#
#		EGADPT - For Paper Tiger printers
#

egadpt.obj:	$(DRIVER_COMMON) drv_dp.inc
	$(ASM) $(PRN_TYP)MATRIX $(PRN_MFG)DP $(PRN_MDL)DPTIGER $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadpt.exe:	egadpt.obj $(LINK_COMMON) video_pc.obj

#
#		EGADOKI - For Okidata 82/83/92/93 printers
#

egadoki.obj:	$(DRIVER_COMMON) drv_oki.inc
	$(ASM) $(PRN_TYP)MATRIX $(PRN_MFG)OKI $(PRN_MDL)OKI82 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadoki.exe:	egadoki.obj $(LINK_COMMON) video_pc.obj

#
#		EGADO292 - Okidata Microline 292 (Non-IBM compatible model)
#

egado292.obj:	$(DRIVER_COMMON) drv_oki.inc
	$(ASM) $(PRN_TYP)COLORMATRIX $(PRN_MFG)OKI $(PRN_MDL)OKI292 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egado292.exe:	egado292.obj $(LINK_COMMON) video_pc.obj

#
#		EGADMPI - For MPI printers
#

egadmpi.obj:	$(DRIVER_COMMON) drv_mpi.inc
	$(ASM) $(PRN_TYP)MATRIX $(PRN_MFG)MPI $(PRN_MDL)MPI99 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadmpi.exe:	egadmpi.obj $(LINK_COMMON) video_pc.obj

#
#		EGADIBJ - IBM Colorjet 3852-2
#

egadibj.obj:	$(DRIVER_COMMON) drv_ibmj.inc
	$(ASM) $(PRN_TYP)COLORINKJET $(PRN_MFG)IBM $(PRN_MDL)IBM3852 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadibj.exe:	egadibj.obj $(LINK_COMMON) video_pc.obj

#
#		EGADXE - For Xerox 4020 printers
#

egadxe.obj:	$(DRIVER_COMMON) drv_xe.inc
	$(ASM) $(PRN_TYP)COLORINKJET2 $(PRN_MFG)XEROX $(PRN_MDL)XEROX4020 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadxe.exe:	egadxe.obj $(LINK_COMMON) video_pc.obj

#
#		EGADDMP - For Radio Shack DMP-105 printers
#
egaddmp.obj:	$(DRIVER_COMMON) drv_rs.inc
	$(ASM) $(PRN_TYP)MATRIX $(PRN_MFG)TANDY $(PRN_MDL)RSDMP105 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egaddmp.exe:	egaddmp.obj $(LINK_COMMON) video_pc.obj

#
#		EGADCGP - For Radio Shack CGP-220 printers
#
egadcgp.obj:	$(DRIVER_COMMON) drv_rs.inc
	$(ASM) $(PRN_TYP)COLORINKJET2 $(PRN_MFG)TANDY $(PRN_MDL)RSCGP220 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadcgp.exe:	egadcgp.obj $(LINK_COMMON) video_pc.obj

#
#		EGADTOSH - For Toshiba P1340, P1350, P3x1 printers
#
egadtosh.obj:	$(DRIVER_COMMON) drv_tosh.inc
	$(ASM) $(PRN_TYP)MAT24 $(PRN_MFG)TOSHIBA $(PRN_MDL)TOSHP3X1 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadtosh.exe:	egadtosh.obj $(LINK_COMMON) video_pc.obj

#
#		EGADCAN - For Canon LBP printers
#
egadcan.obj:	$(DRIVER_COMMON) drv_can.inc
	$(ASM) $(PRN_TYP)LASER $(PRN_MFG)CANON $(PRN_MDL)LBP4 $(ASM_OPTS) egaddrv,$*.obj,$(LIST);

egadcan.exe:	egadcan.obj $(LINK_COMMON) video_pc.obj


#
#		Update distribution directories:
#

always:
	xcopy	egad*.exe ..\pc\*.*
#	move	egad*.exe \work\egad\oem\egad*.exe
