	PAGE	,132
;
;	EGAD Screen Print
;
;	COPYRIGHT (C) 1993 LS Software
;
;	* BIOS data areas
;	* Computer specific configuration
;	* Other configuration parameters
;

_DATA		SEGMENT WORD PUBLIC 'DATA'
_DATA		ENDS
STACK		SEGMENT	PARA STACK  'STACK'
STACK		ENDS
_TEXT		SEGMENT	WORD PUBLIC 'CODE'
_TEXT		ENDS
START_TEXT	SEGMENT	WORD PUBLIC 'INIT'
START_TEXT	ENDS
START_DATA	SEGMENT	WORD PUBLIC 'INIT'
START_DATA	ENDS

DGROUP	GROUP	_DATA, STACK, _TEXT, START_TEXT, START_DATA
	ASSUME	CS:_TEXT, DS:_DATA, SS:STACK, ES:_DATA

;
;	Maximum supported video mode
;
MAX_MODE EQU 14h

;
;	Port parameters
;
MAX_SERPORT	equ	4	; Allow COM1..COM4
MAX_PARPORT	equ	3	; Allow LPT1..LPT3

;
;	Keystroke equates.
;
get_key_status	equ	01h
;	These are the values returned by GETBOX:
Escape_key	equ	0011bh
nr_0_key	equ	00b30h
nr_1_key	equ	00231h
nr_2_key	equ	00332h
nr_3_key	equ	00433h
nr_4_key	equ	00534h
xmode_key	equ	0FFFFh

;
;	BIOS Segment definitions
;
_BIOS   segment at 0040h
		ASSUME	CS:_BIOS
		ORG	12
ZBIOS_PRINT	LABEL	FAR	; Z-100 Printer output
		ORG	4AH	; BIOS: # of columns
 screen_cols	db	?
		ORG	4CH	; BIOS: # of displayed bytes
 screen_size	dw	?
		ORG	4EH	; BIOS: Offset to current video page
 page_offset	dw	?
		ORG	63H	; BIOS: Active Display Adapter Register Addr.
 screen_port	dw	?
		ORG	6CH	; BIOS: Timer tick count
 timer_tick	db	?
		ORG	0084H	; BIOS: lines on screen -1 (if EGA)
 screen_lines	db 	?
 font_height    db	?	; BIOS: Scan lines/character
		ORG	100H
 busy_flag	DB	?	; Busy flag offset in BIOS data segment
 not_busy	=	0	;  0 = screen dump complete
 is_busy	=	1	;  1 = screen dump in progress
 err_busy	=	0FFH	; FF = error while printing
_BIOS	ends

		ASSUME	CS:NOTHING

;
;	Forced video modes
;
FORCE_NORM	equ	0	; Not forced (normal)
FORCE_TEXT	equ	1
FORCE_GFX	equ	2

;
;	Crop box configuration
;
MAX_X_SIZE EQU 800
MAX_Y_SIZE EQU 600

BOX_BUF_SIZ EQU	(MAX_X_SIZE+MAX_Y_SIZE)*2+8	; Size of crop box buffer

;
; Configuration Values, passed from caller
;
PG_FF_AFTER	EQU	1	; Eject page after printing
PG_RESET_BEFORE	EQU	2	; Reset printer before beginning
PG_DONT_PRINT	EQU	8	; Disable printing; send FF only

CFG_LEN	EQU	30	; Size (in bytes) of CONFIG_DATA structure:

JUST_LEFT   = 1
JUST_TOP    = 1
JUST_RIGHT  = 2
JUST_BOTTOM = 2
JUST_CENTER = 3

CONFIG_DATA STRUC
;
;	SETEGAD - Configurable options:
;
x1	dw	1	; x upper left corner
y1	dw	1	; y upper left corner
x2	dw	1	; x lower right corner
y2	dw	1	; y lower right corner

do_ff	dw	0	; 0=no FF; 1=FF after; 3=FF before&after; 8=FF only
prn_un	dw	1	; Printer unit (1=LPT1, -1=COM1)
enlarge	dw	1	; Enlargement factor
vga_divisor dw	1	; Divisor for 256-color modes
box     dw	1	; 0 no crop box, != 0 put up box
centering  dw	0	; 0 = N/A, JUST_LEFT, JUST_RIGHT, JUST_CENTER
vcentering db	0	; 0 = N/A, JUST_TOP, JUST_BOTTOM, JUST_CENTER
tsrflags   db	0	; bit fields as described below (TSRF_*)
orient	dw	0	; 0 = Auto orientation, 1 = Portrait, 2 = Landscape
;
; Used by crop box logic:
;
colora	dw	15	; Color of currently-adjusted corner of crop box
colorb	dw	1	; Color of 'dead' corner of crop box
incr	dw	1	; increment when adjusting crop box
CONFIG_DATA ENDS

TSRF_NORMAL	equ	0	; normal
TSRF_REVCOLOR	equ	80h	; reverse color table

; Offset in EGAD data segment of signature (# of items in Config block).
SIG_LOC = 4
; Offset in EGAD data segment of beginning of Configuration block.
; (Follows 'QZ' + 'xx' + signature + color palette.)
PAL_LEN = (2+4+16+16)*2
CFG_LOC = SIG_LOC+2+PAL_LEN
; Offset in EGAD data segment where the PSP of an installed TSR is located.
; This is used so we can free its memory when removing it.
MCB_LOC = CFG_LOC+CFG_LEN+4

; Interrupts
vid_int		= 10h	; BIOS video interrupt
key_int		= 16h	; Keyboard interrupt
dos_int		= 21h	; MS-DOS
prtsc_int	= 05h	; BIOS Print Screen
prn_int		= 17h	; BIOS Printer
ser_int		= 14H	; BIOS Serial I/O

; Contents of video_size.vmode_flags:
vm_text		equ	001h	; TRUE if Text mode
vm_varsize	equ	002h	; TRUE if variable size (text or graphics)
vm_egaregs	equ	004h	; TRUE if read/write logic uses EGA registers
vm_mono		equ	008h	; Is a monochrome mode
vm_monox	equ	010h	; Possibly monochrome mode

; Contents of video_size.vmode_palette:
vm_pal_pbits	equ	00fh	; Which palette:
 vm_pal_2	equ	  0	;   Graphics:	monochrome
 vm_pal_4	equ	  1	;		4 color
 vm_pal_16	equ	  2	;		16/256 color
 vm_pal_t	equ	  3	;   Text
vm_pal_aspect	equ	0f0h	; this nybble is which aspect ratio.
				; Note: The value (0..4) becomes the
				; index into the GFXMAP array.
 vm_asp_320	equ	000h	;	320x200 gfx
 vm_asp_640c	equ	010h	;	640x200 gfx
 vm_asp_640e	equ	020h	;	640x350 gfx
 vm_asp_640v	equ	030h	;	640x480 gfx (and Super VGA)
 vm_asp_herc	equ	040h	;	Hercules gfx

video_size struc
 vmode_flags	db	?
 ; These two words indicate the size of the display
 vmode_cols	dw	?
 vmode_rows	dw	?
 ; The following words are EGAD characteristics
 vmode_maxcolor db	?
 vmode_definc	db	?
 vmode_palette  db	?
video_size ends

;
;	Useful macros
;
DISPLY	MACRO TEXT
 IFNB <TEXT>
	MOV	DX,OFFSET DGROUP:TEXT
 ENDIF
	CALL	$DISP
	ENDM

;PRINTE MACRO exp,val
;	IF2
;	%OUT exp = val
;	ENDIF
;	ENDM

CLEAR	MACRO	reg
	sub	reg,reg
	endm

	ASSUME	CS:_TEXT, DS:_DATA, SS:STACK, ES:_DATA
